//+------------------------------------------------------------------+
//|                                         EMA-Crossover_Signal.mq4 |
//|         Copyright  2005, Jason Robinson (jnrtrading)            |
//|                   http://www.jnrtading.co.uk                     |
//+------------------------------------------------------------------+

#property copyright "Copyright  2005, Jason Robinson (jnrtrading)"
#property link      "http://www.jnrtrading.co.uk"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Red

double CrossUp[];
double CrossDown[];
extern int MA_Period = 2;
extern int MA_Method = MODE_SMMA;
extern bool SoundON=true;
extern bool EmailON=true;
double alertTag;
double control=2147483647;
 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY,3);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY,3);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDown);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit, i, counter;
   double MAnow, Pivotnow, MAprevious, Pivotprevious, MAafter, Pivotafter;
   double Range, AvgRange;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   for(i = 0; i <= limit; i++) {
   
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
       
      MAnow = iMA(NULL, 0, MA_Period, 0, MA_Method, PRICE_WEIGHTED, i);
      MAprevious = iMA(NULL, 0, MA_Period, 0, MA_Method, PRICE_WEIGHTED, i+1);
      MAafter = iMA(NULL, 0, MA_Period, 0, MA_Method, PRICE_WEIGHTED, i-1);

      Pivotnow = iCustom(NULL, 0, "PrevDayAndFloatingPivot_O", 0, i);
      Pivotprevious = iCustom(NULL, 0, "PrevDayAndFloatingPivot_O", 0, i+1);
      Pivotafter = iCustom(NULL, 0, "PrevDayAndFloatingPivot_O", 0, i-1);
      
      if ((MAnow > Pivotnow) && (MAprevious < Pivotprevious) && (MAafter > Pivotafter)) {
         CrossUp[i] = Low[i] - Range*0.5;
      }
      else if ((MAnow < Pivotnow) && (MAprevious > Pivotprevious) && (MAafter < Pivotafter)) {
          CrossDown[i] = High[i] + Range*0.5;
      }
        if (SoundON==true && i==1 && CrossUp[i] > CrossDown[i] && alertTag!=Time[0]){
         Alert("MA Cross Trend going Down on ",Symbol()," ",Period());
            if (EmailON==true) {
               SendMail("The Only Pivot Alert !","MA Cross TheOnlyPivot going Down on "+Symbol()+" , Period : "+Period());
            }
        alertTag = Time[0];
      }
        if (SoundON==true && i==1 && CrossUp[i] < CrossDown[i] && alertTag!=Time[0]){
       Alert("MA Cross Trend going Up on ",Symbol()," ",Period());
            if (EmailON==true) {
               SendMail("The Only Pivot Alert !","MA Cross TheOnlyPivot going Up on "+Symbol()+" , Period : "+Period());
            }
        alertTag = Time[0];
        } 
  }
   return(0);
}

